{
  description = "A very basic flake";

  inputs = {
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
  flake-utils.lib.eachDefaultSystem (system:
  let
    pkgs = nixpkgs.legacyPackages.${system};
    pythonPkgs = pkgs.python39Packages;

    myPkgs = rec {
      agtest = pythonPkgs.callPackage ./. {};
      agtest-docs = pythonPkgs.callPackage ./docs {};
    };
  in
  rec {
    packages = flake-utils.lib.flattenTree myPkgs;

    defaultPackage = packages.agtest;

    devShell = pkgs.mkShell {
      packages = with pythonPkgs; [
        black
      ];
    };
  });
}
